#include "..\..\include\c\athsdk.h"

LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
#define COMPRESS_FILE_CMD 100
#define COMPRESSION_IN_PROGRESS "Compression in progress...\nPlease wait until it beeps."
char szClassName[] = "HTMLAthleteExample";
char szHitThisButtonWhenDone[]="Hit this button when done.";
char szFileName[256];
HWND _hwnd,_edit,_button,_static,_contentType,_html,_js,_css;

// You must load and initialize the DLL (this step is automatically done when using Delphi)
ATH_LOAD_LIBRARY("athsdk.dll")
/*typedef ATHResult __stdcall (CALLBACK *DPf)(ATHInstance,HWND);
DPf ATHShowAboutDialogue=(DPf)GetProcAddress(LoadLibrary("athsdk.dll"),"ATHShowAboutDialogue");
 */
// *********************************************
// *  THE ESSENTIAL PROCEDURE OF THIS EXAMPLE  *
// *********************************************
// starts the compression of the file given in fileName parameter
void CompressFile(char *fileName){
     // You must load and initialize the DLL (this step is automatically done when using Delphi)
        // this is done just above this function
        //ATH_LOAD_LIBRARY("athsdk.dll")
     // First we declare the variable which the instance will be stored in
     ATHInstance myInstance;
     // Then we create such one
     ATHCreateInstance(&myInstance);
     // Your authorization comes here
     // ATHAuthorizeInstance(myInstance,{ your validation text },{ validation code you will be send to });
     // You can set the instance's property to true, or false and this way control the behaviour of compression.
     // On the following line we invoke the HTML Athlete's standard setting dialogue
     if (ATHShowSettingDialogue(myInstance,_hwnd)==ATH_RESULT_OK){
        // If the input content can vary, you must always choose the right content identifier in order to run
        // the compression in corrent mode. Here it is quite simple because we confide the user has chosen the right one
        // by pressing one of radio buttons shown in the GUI.
        ATHContentType contentType;
             if (SendMessage(_html,BM_GETCHECK,1,1)>0) contentType=ATH_CONTENT_TYPE_HTML;
        else if (SendMessage(_js,BM_GETCHECK,1,1)>0) contentType=ATH_CONTENT_TYPE_JS;
        else contentType=ATH_CONTENT_TYPE_CSS;
        // After having all properties set to richt values and chosen the richt content identifier, you are ready to
        // run the compression.
        switch (ATHCompressFile(myInstance,contentType,fileName)){
            case ATH_RESULT_OK:break;
            case ATH_RESULT_CAN_NOT_READ_FILE:MessageBox(0,"Can not read the file. Please check whether you put in the correct name.","Error occured",0); break;
            case ATH_RESULT_CAN_NOT_WRITE_FILE:MessageBox(0,"Can not write the compressed data into the file. Please check whether the disk is not full and you are given the write access privilege.","Error occured",0);
            default:MessageBox(0,"An unexpected error arose. Please check the correctness of the input.","Error occured",0);
        }
     }
     // Once the compression is done and the HTML Athlete instance is no longer needed you can simply destroy it.
     if (ATHDestroyInstance(myInstance)!=ATH_RESULT_OK){
        MessageBox(0,"Can not destroy the HTML Athlete instance.","Error occured",0);
     }
     // in contrast to Delphi users, the C users have to call the following macro in order to properly unload the formerly loaded DLL
        // this is done after the message loop
        //ATH_FREE_LIBRARY
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil){
    MSG messages;
    WNDCLASSEX wc;

    // try to register the main window class
    ZeroMemory(&wc,sizeof(WNDCLASSEX));
    wc.cbSize=sizeof(WNDCLASSEX);
    wc.hInstance=hInstance;
    wc.lpszClassName=szClassName;
    wc.lpfnWndProc=WindowProcedure;
    wc.style=CS_DBLCLKS;
    wc.hIcon=LoadIcon(NULL, IDI_WINLOGO);
    wc.hIconSm=LoadIcon(NULL, IDI_WINLOGO);
    wc.hCursor=LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground=(HBRUSH)COLOR_WINDOW;
    if(!RegisterClassEx(&wc)) return 0;
    // try to create the main window
    _hwnd=CreateWindowEx(0,szClassName,"HTML Athlete Example",WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,300,200,HWND_DESKTOP,NULL,hInstance,NULL);

    // create the static text
    _static=CreateWindowEx(0,"STATIC","Type the name of the file to compress:",WS_CHILD | WS_VISIBLE | ES_LEFT,10,10,250,20,_hwnd,NULL,hInstance,NULL);
    // create the input edit box in which you write the name of the file you want compress
    _edit=CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT","example.html",WS_CHILD | WS_VISIBLE,10,30,270,20,_hwnd,NULL,hInstance,NULL);
    // create the radio button group and set the HTML button checked
    _contentType=CreateWindowEx(0,"BUTTON","Select the data type:",WS_CHILD | WS_VISIBLE | ES_LEFT | BS_GROUPBOX,
                                 10,55,270,50,_hwnd,NULL,hInstance,NULL);
    _html=CreateWindowEx(0,"BUTTON","HTML",WS_CHILD | WS_VISIBLE | ES_LEFT | BS_AUTORADIOBUTTON,
                                 10,20,70,20,_contentType,NULL,hInstance,NULL);
    SendMessage(_html,BM_SETCHECK,1,0);
    _js=CreateWindowEx(0,"BUTTON","JavaScript",WS_CHILD | WS_VISIBLE | ES_LEFT | BS_AUTORADIOBUTTON,
                                 80,20,90,20,_contentType,NULL,hInstance,NULL);
    _css=CreateWindowEx(0,"BUTTON","CSS",WS_CHILD | WS_VISIBLE | ES_LEFT | BS_AUTORADIOBUTTON,
                                 183,20,60,20,_contentType,NULL,hInstance,NULL);
    // create the button starting the compression and having the menu ID set to COMPRESS_FILE_ID
    _button=CreateWindowEx(WS_EX_CLIENTEDGE,"BUTTON",szHitThisButtonWhenDone,WS_CHILD | WS_VISIBLE | ES_LEFT | BS_PUSHBUTTON | BS_MULTILINE,
                                 10,110,270,55,_hwnd,(HMENU)COMPRESS_FILE_CMD,hInstance,NULL);

    // as a greeting the About dialog box appears
    ATHShowAboutDialogue(0,_hwnd);

    // loop in the cycle until the user presses the Close Window button in the right upper corner
    while(GetMessage(&messages,NULL,0,0)){
           TranslateMessage(&messages);
           DispatchMessage(&messages);
    }

    // in contrast to Delphi users, the C users have to call the following macro in order to properly unload the formerly loaded DLL
    ATH_FREE_LIBRARY

    // unregister the formerly registered window class
    UnregisterClass(szClassName,hInstance);
    // destroy all components and the window itself
    DestroyWindow(_static); DestroyWindow(_button); DestroyWindow(_edit);
    DestroyWindow(_css); DestroyWindow(_js); DestroyWindow(_html); DestroyWindow(_contentType);
    DestroyWindow(_hwnd);
    return messages.wParam;
}

// serves the incoming message
LRESULT CALLBACK WindowProcedure(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
    switch (message){
           case WM_DESTROY:PostQuitMessage(0);break;
           case WM_COMMAND:switch (LOWORD(wParam)){
                                  case COMPRESS_FILE_CMD:GetWindowText(_edit,szFileName,255);
                                                         SetWindowText(_button,COMPRESSION_IN_PROGRESS);
                                                         CompressFile(szFileName);
                                                         SetWindowText(_button,szHitThisButtonWhenDone);
                                                         break;
                           }
                           break;
           default:return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}
