program HTMLAthleteExample;
uses windows,
  messages,
  commctrl,
  athsdk in '..\..\include\delphi\athsdk.pas';
{!$apptype console}
const CLASS_NAME='HTMLAthleteExample';
      COMPRESS_FILE_CMD=100;
      HIT_THIS_BUTTON_WHEN_DONE='Hit this button when done.';
      COMPRESSION_IN_PROGRESS='Compression in progress...'+#13+'Please wait until it beeps.';


var _msg:TMsg;
    _hwnd,_edit,_button,_static,_contentType,_html,_js,_css:THandle;
    fileName:array[byte] of char;

    procedure CompressFile(fileName:pchar);
    // *********************************************
    // *  THE ESSENTIAL PROCEDURE OF THIS EXAMPLE  *
    // *********************************************
    // starts the compression of the file given in fileName parameter
    var contentType:ATHContentType;
        myInstance:ATHInstance;
    begin
         // First we create an instance of HTML Athlete compression routine.
         if ATHCreateInstance(myInstance)<>ATH_RESULT_OK then begin
            MessageBox(0,'Could not create the HTML Athlete instance.','Error occured',0); exit;
         end;
         // Your authorization comes here.
         // ATHAuthorizeInstance(myInstance,{ your validation text },{ validation code you will be send to });
         // You can set the instance's property to true, or false and this way control the behaviour of compression.
         // On the following line we invoke HTML Athlete's standard setting dialogue
         if ATHShowSettingDialogue(myInstance,_hwnd)=ATH_RESULT_OK then begin
            // If the input content can vary, you must always choose the richt content identifier in order to run
            // the compression in corrent mode. Here it is quite simple because we confide the user has chosen the right one
            // by pressing one of radio buttons shown in the GUI.
                 if SendMessage(_html,BM_GETCHECK,1,1)>0 then contentType:=ATH_CONTENT_TYPE_HTML
            else if SendMessage(_js,BM_GETCHECK,1,1)>0 then contentType:=ATH_CONTENT_TYPE_JS
            else contentType:=ATH_CONTENT_TYPE_CSS;
            // After having all properties set to richt values and chosen the richt content identifier, you are ready to
            // run the compression.
            case ATHCompressFile(myInstance,contentType,fileName) of
                 ATH_RESULT_OK:;
                 ATH_RESULT_CAN_NOT_READ_FILE:MessageBox(0,'Can not read the file. Please check whether you put in the correct name.','Error occured',0);
                 ATH_RESULT_CAN_NOT_WRITE_FILE:MessageBox(0,'Can not write the compressed data into the file. Please check whether the disk is not full and you are given the write access privilege.','Error occured',0);
                 else MessageBox(0,'An unexpected error arose. Please check the correctness of the input.','Error occured',0);
            end;
         end;
         // Once the compression is done and the HTML Athlete instance is no longer needed you can simply destroy it.
         if ATHDestroyInstance(myInstance)<>ATH_RESULT_OK then
            MessageBox(0,'Can not destroy the HTML Athlete instance.','Error occured',0);
    end;

    function WindowProcMain(hwnd:HWND;uMsg:UINT;wparam:wparam;lparam:lparam):LResult; stdcall;
    // serves the incoming message
    begin
         case umsg of WM_DESTROY,WM_QUIT:PostQuitMessage(0);
                      WM_COMMAND:case lo(wparam) of COMPRESS_FILE_CMD:begin
                                                                           GetWindowText(_edit,fileName,255);
                                                                           SetWindowText(_button,COMPRESSION_IN_PROGRESS);
                                                                           CompressFile(fileName);
                                                                           SetWindowText(_button,HIT_THIS_BUTTON_WHEN_DONE);
                                                                      end;     
                                 end;      
         end;
         result:=DefWindowProc(hwnd,uMsg,wparam,lparam);
    end;

    function CreateMainWindow:boolean;
    // creates the main window; returns True when suceeded, False otherwise
    var wc:TWndClassEx;
    begin
         // try to register the main window class
         ZeroMemory(@wc,sizeof(TWndClassEx));
         wc.cbSize:=sizeof(TWndClassEx);
         wc.hbrBackground:=COLOR_WINDOW;
         wc.hCursor:=LoadCursor(0,IDC_ARROW);
         wc.hIcon:=LoadIcon(0,IDI_WINLOGO);
         wc.hIconSm:=LoadIcon(0,IDI_WINLOGO);
         wc.hInstance:=hInstance;
         wc.lpfnWndProc:=@WindowProcMain;
         wc.lpszClassName:=CLASS_NAME;
         wc.style:=CS_HREDRAW or CS_VREDRAW;
         if RegisterClassEx(wc)=0 then begin
            result:=false; exit;
         end;
         // try to create the main window
         _hwnd:=CreateWindowEx(0,CLASS_NAME,'HTML Athlete Example',WS_OVERLAPPEDWINDOW or WS_VISIBLE,0,0,300,200,0,0,hinstance,nil);
         if _hwnd=0 then begin
            result:=false; exit;
         end;
         result:=true;
    end;

begin
     // try to create the window
     if not CreateMainWindow then begin
        MessageBox(0,'Unable to create the main window. Exiting.','Error occured',0); exit;
     end;
     // create the static text
     _static:=CreateWindowEx(0,'STATIC','Type the name of the file to compress:',WS_CHILD or WS_VISIBLE or ES_LEFT,10,10,250,20,_hwnd,0,hInstance,nil);
     // create the input edit box in which you write the name of the file you want compress
     _edit:=CreateWindowEx(WS_EX_CLIENTEDGE,'EDIT','example.html',WS_CHILD or WS_VISIBLE,10,30,270,20,_hwnd,0,hinstance,nil);
     // create the radio button group and set the HTML button checked
     _contentType:=CreateWindowEx(0,'BUTTON','Select the data type:',WS_CHILD or WS_VISIBLE or ES_LEFT or BS_GROUPBOX,
                             10,55,270,50,_hwnd,0,hInstance,nil);
     _html:=CreateWindowEx(0,'BUTTON','HTML',WS_CHILD or WS_VISIBLE or ES_LEFT or BS_AUTORADIOBUTTON,
                             10,20,70,20,_contentType,COMPRESS_FILE_CMD,hInstance,nil);
     SendMessage(_html,BM_SETCHECK,1,0);
     _js:=CreateWindowEx(0,'BUTTON','JavaScript',WS_CHILD or WS_VISIBLE or ES_LEFT or BS_AUTORADIOBUTTON,
                             80,20,90,20,_contentType,0,hInstance,nil);
     _css:=CreateWindowEx(0,'BUTTON','CSS',WS_CHILD or WS_VISIBLE or ES_LEFT or BS_AUTORADIOBUTTON,
                             183,20,60,20,_contentType,0,hInstance,nil);
     // create the button starting the compression and having the menu ID set to COMPRESS_FILE_ID
     _button:=CreateWindowEx(WS_EX_CLIENTEDGE,'BUTTON',HIT_THIS_BUTTON_WHEN_DONE,WS_CHILD or WS_VISIBLE or ES_LEFT or BS_PUSHBUTTON or BS_MULTILINE,
                             10,110,270,55,_hwnd,COMPRESS_FILE_CMD,hInstance,nil);

     // as a greeting the About dialog appears
     ATHShowAboutDialogue(0,_hwnd);

     // loop in the cycle until the user presses the Close Window button in the right upper corner
     while GetMessage(_msg,0,0,0) do begin
           TranslateMessage(_msg);
           DispatchMessage(_msg);
     end;

     // unregister the formerly registered window class
     UnregisterClass(CLASS_NAME,hInstance);
     // destroy all components and the window itself
     DestroyWindow(_static); DestroyWindow(_button); DestroyWindow(_edit);
     DestroyWindow(_css); DestroyWindow(_js); DestroyWindow(_html); DestroyWindow(_contentType);
     DestroyWindow(_hwnd);
end.
