#include <windows.h>

// definition of constants
#define ATH_RESULT_OK							0
#define ATH_RESULT_BUSY							1
#define ATH_RESULT_ERROR_CREATING_AN_INSTANCE				2
#define ATH_RESULT_UNKNOWN_INSTANCE					3
#define ATH_RESULT_UNKNOWN_PROPERTY 					4
#define ATH_RESULT_UNKNOWN_CONTENT_TYPE					5
#define ATH_RESULT_STILL_UNAUTHORIZED 					6
#define ATH_RESULT_CAN_NOT_READ_FILE 					7
#define ATH_RESULT_CAN_NOT_WRITE_FILE 					8
#define ATH_RESULT_UNKNOWN_BEHAVIOUR 					9
#define ATH_RESULT_IDLE 						10
#define ATH_RESULT_UNKNOWN_THREAD_PRIORITY 				11
#define ATH_RESULT_GENERAL_COMPRESSION_ERROR 				12
#define ATH_RESULT_UNKNOWN_LANGUAGE					13
#define ATH_RESULT_CANCEL						14

#define ATH_PROPERTY_DELETE_HTML_COMMENTS 				1
#define ATH_PROPERTY_PROTECT_EVENTS 					2
#define ATH_PROPERTY_JS_COMPRESSION_ENABLED 				4
#define ATH_PROPERTY_CSS_COMPRESSION_ENABLED 				8
#define ATH_PROPERTY_HIDE_JS_IN_OLDER_BROWSERS 				16
#define ATH_PROPERTY_BEEP_WHEN_FINISHED 				32

#define ATH_CONTENT_TYPE_JS 						1
#define ATH_CONTENT_TYPE_HTML 						2
#define ATH_CONTENT_TYPE_CSS 						3

#define ATH_BEHAVIOUR_BLOCK 						0
#define ATH_BEHAVIOUR_NOTIFY_SENDING_A_MESSAGE 				1
#define ATH_BEHAVIOUR_DONT_BLOCK 					2

#define ATH_PADDING_LEFT 						9
#define ATH_PADDING_RIGHT 						9

#define ATH_LANGUAGE_ENGLISH						1
#define ATH_LANGUAGE_CESKY						2
#define ATH_LANGUAGE_DEUTSCH						3


// definition of types
typedef int ATHInstance;
typedef unsigned char ATHContentType;
typedef unsigned char ATHResult;
typedef unsigned char ATHProperty;
typedef unsigned char ATHBehaviour;
typedef unsigned char ATHLanguage;
typedef unsigned char ATHPropertyValue;
typedef struct{
		HWND window;
		unsigned int messageId;
} ATHTCompressionDoneMessage,*ATHPCompressionDoneMessage;


// definition of macros
#define __ATH_LOAD_FUNCTION__(T,V,F) \
	T V=(T)GetProcAddress(athdll,F);

#define ATH_LOAD_FUNCTION(Typ,Def,Var,Fun) \
	typedef ATHResult __stdcall (CALLBACK *Typ)Def;\
	__ATH_LOAD_FUNCTION__(Typ,Var,Fun)

#define ATH_LOAD_LIBRARY(athsdk) \
	HINSTANCE athdll=LoadLibrary(athsdk);\
/*	if((athdll=LoadLibrary(athsdk))==NULL){\
		MessageBox(0,"ERROR OCCURED:\nThe HTML Athlete SDK dynamic library could not be loaded due to its absence in the given directory. The program may unexpectedly break down after you press the OK button.","HTML Athlete: Error loading the DLL",MB_ICONERROR | MB_OK);\
	}\
*/	ATH_LOAD_FUNCTION(PATHCreateInstance,(ATHInstance*),ATHCreateInstance,"ATHCreateInstance")\
	ATH_LOAD_FUNCTION(PATHDestroyInstance,(ATHInstance),ATHDestroyInstance,"ATHDestroyInstance")\
	ATH_LOAD_FUNCTION(PATHAuthorizeInstance,(ATHInstance,char*,char*),ATHAuthorizeInstance,"ATHAuthorizeInstance")\
	ATH_LOAD_FUNCTION(PATHSetProperty,(ATHInstance,ATHProperty,ATHPropertyValue),ATHSetProperty,"ATHSetProperty")\
	ATH_LOAD_FUNCTION(PATHSetCallerBehaviour,(ATHInstance,ATHBehaviour,void*),ATHSetCallerBehaviour,"ATHSetCallerBehaviour")\
	ATH_LOAD_FUNCTION(PATHCompressRawData,(ATHInstance,ATHContentType,char*,char**,void*),ATHCompressRawData,"ATHCompressRawData")\
	ATH_LOAD_FUNCTION(PATHCompressFile,(ATHInstance,ATHContentType,char*),ATHCompressFile,"ATHCompressFile")\
	ATH_LOAD_FUNCTION(PATHGetCharsProcessed,(ATHInstance,int*),ATHGetCharsProcessed,"ATHGetCharsProcessed")\
	ATH_LOAD_FUNCTION(PATHSetWorkerThreadPriority,(ATHInstance,int),ATHSetWorkerThreadPriority,"ATHSetWorkerThreadPriority")\
	ATH_LOAD_FUNCTION(PATHSetLanguage,(ATHInstance,ATHLanguage),ATHSetLanguage,"ATHSetLanguage")\
	ATH_LOAD_FUNCTION(PATHShowSettingDialogue,(ATHInstance,HWND),ATHShowSettingDialogue,"ATHShowSettingDialogue")\
	ATH_LOAD_FUNCTION(PATHShowAboutDialogue,(ATHInstance,HWND),ATHShowAboutDialogue,"ATHShowAboutDialogue")\
	typedef int __stdcall (CALLBACK *PATHGetVersion)();\
	__ATH_LOAD_FUNCTION__(PATHGetVersion,ATHGetVersion,"ATHGetVersion")\
	;

#define ATH_FREE_LIBRARY \
	FreeLibrary(athdll);

