unit athsdk;

interface
uses windows;
const ATH_RESULT_OK                                                       = 0;
      ATH_RESULT_BUSY                                                     = 1;
      ATH_RESULT_ERROR_CREATING_AN_INSTANCE                               = 2;
      ATH_RESULT_UNKNOWN_INSTANCE                                         = 3;
      ATH_RESULT_UNKNOWN_PROPERTY                                         = 4;
      ATH_RESULT_UNKNOWN_CONTENT_TYPE                                     = 5;
      ATH_RESULT_STILL_UNAUTHORIZED                                       = 6;
      ATH_RESULT_CAN_NOT_READ_FILE                                        = 7;
      ATH_RESULT_CAN_NOT_WRITE_FILE                                       = 8;
      ATH_RESULT_UNKNOWN_BEHAVIOUR                                        = 9;
      ATH_RESULT_IDLE                                                     = 10;
      ATH_RESULT_UNKNOWN_THREAD_PRIORITY                                  = 11;
      ATH_RESULT_GENERAL_COMPRESSION_ERROR                                = 12;
      ATH_RESULT_UNKNOWN_LANGUAGE                                         = 13;
      ATH_RESULT_CANCEL                                                   = 14;

      ATH_PROPERTY_DELETE_HTML_COMMENTS                                   = 1;
      ATH_PROPERTY_PROTECT_EVENTS                                         = 2;
      ATH_PROPERTY_JS_COMPRESSION_ENABLED                                 = 4;
      ATH_PROPERTY_CSS_COMPRESSION_ENABLED                                = 8;
      ATH_PROPERTY_HIDE_JS_IN_OLDER_BROWSERS                              = 16;
      ATH_PROPERTY_BEEP_WHEN_FINISHED                                     = 32;

      ATH_CONTENT_TYPE_JS                                                 = 1;
      ATH_CONTENT_TYPE_HTML                                               = 2;
      ATH_CONTENT_TYPE_CSS                                                = 3;

      ATH_BEHAVIOUR_BLOCK                                                 = 0;
      ATH_BEHAVIOUR_NOTIFY_SENDING_A_MESSAGE                              = 1;
      ATH_BEHAVIOUR_DONT_BLOCK                                            = 2;

      ATH_PADDING_LEFT                                                    = 9;
      ATH_PADDING_RIGHT                                                   = 9;

      ATH_LANGUAGE_ENGLISH                                                = 1;
      ATH_LANGUAGE_CESKY                                                  = 2;
      ATH_LANGUAGE_DEUTSCH                                                = 3;

type ATHInstance=integer;
     ATHContentType=byte;
     ATHResult=byte;
     ATHProperty=byte;
     ATHBehaviour=byte;
     ATHLanguage=byte;
     ATHPropertyValue=boolean;
     ATHPCompressionDoneMessage=^ATHTCompressionDoneMessage;
     ATHTCompressionDoneMessage=record
                                      window:HWND;
                                      messageId:uint;
     end;

    function ATHCreateInstance(var instance:ATHInstance):ATHResult; stdcall;
    function ATHDestroyInstance(instance:ATHInstance):ATHResult; stdcall;
    function ATHAuthorizeInstance(instance:ATHInstance;authText,authKey:pchar):ATHResult; stdcall;
    function ATHSetProperty(instance:ATHInstance;_properties:ATHProperty;value:ATHPropertyValue):ATHResult; stdcall;
    function ATHSetCallerBehaviour(instance:ATHInstance;behaviour:ATHBehaviour;param:pointer):ATHResult; stdcall;
    function ATHCompressRawData(instance:ATHInstance;contentType:ATHContentType;data:pchar;var endOfOutput:pchar;param:pointer):ATHResult; stdcall;
    function ATHCompressFile(instance:ATHInstance;contentType:ATHContentType;soubor:pchar):ATHResult; stdcall;
    function ATHGetCharsProcessed(instance:ATHInstance;var charsProcessed:integer):ATHResult; stdcall;
    function ATHSetWorkerThreadPriority(instance:ATHInstance;priority:integer):ATHResult; stdcall;
    function ATHSetLanguage(instance:ATHInstance;language:ATHLanguage):ATHResult; stdcall;
    function ATHShowSettingDialogue(instance:ATHInstance;parentWnd:HWND):ATHResult; stdcall;
    function ATHShowAboutDialogue(instance:ATHInstance;parentWnd:HWND):ATHResult; stdcall;
    function ATHGetVersion:integer; stdcall;

implementation
const athdll='athsdk.dll';

    function ATHCreateInstance;
             external athdll name 'ATHCreateInstance';
    function ATHDestroyInstance;
             external athdll name 'ATHDestroyInstance';
    function ATHAuthorizeInstance;
             external athdll name 'ATHAuthorizeInstance';
    function ATHSetProperty;
             external athdll name 'ATHSetProperty';
    function ATHSetCallerBehaviour;
             external athdll name 'ATHSetCallerBehaviour';
    function ATHCompressRawData;
             external athdll name 'ATHCompressRawData';
    function ATHCompressFile;
             external athdll name 'ATHCompressFile';
    function ATHGetCharsProcessed;
             external athdll name 'ATHGetCharsProcessed';
    function ATHSetWorkerThreadPriority;
             external athdll name 'ATHSetWorkerThreadPriority';
    function ATHSetLanguage;
             external athdll name 'ATHSetLanguage';
    function ATHShowSettingDialogue;
             external athdll name 'ATHShowSettingDialogue';
    function ATHShowAboutDialogue;
             external athdll name 'ATHShowAboutDialogue';
    function ATHGetVersion;
             external athdll name 'ATHGetVersion';

end.
